/**
 * 
 */
package sim.application.util;

import java.awt.BorderLayout;
import java.awt.image.BufferedImage;

import javax.swing.JFrame;
import javax.swing.border.EmptyBorder;

/**
 * La classe <b>SJFrameTexture</b> reprsentant un JFrame permettant d'afficher une texture  l'cran.
 * 
 * @author Simon Vzina
 * @since 2018-03-06
 * @version 2020-03-18
 */
public class SJFrameImage extends JFrame {

  private final static boolean DEFAULT_INTERPOLATION = true;
  
  private static final int INI_X = 100;
  private static final int INI_Y = 100;
  private static final int DS = 5;
  
  /**
   * La variable <b>translation</b> permet d'afficher une squence de frame avec une lgre translation
   * afin que les fentres ne soient pas les unes sur les autres.
   */
  private static int translation = 0;
  
  /**
   * 
   */
  private static final long serialVersionUID = -4538680711957925848L;
  
  private SJPanelImage contentPane;
  
  /**
   * ...
   * 
   * @param frame_name
   * @param texture
   */
  /*
  public SJFrameTexture(String frame_name, STexture texture)
  {
    this(frame_name, texture, DEFAULT_INTERPOLATION);
  }
  */
  
  /**
   * ...
   * 
   * @param frame_name
   * @param texture
   * @param interpolation
   */
  /*
  public SJFrameTexture(String frame_name, STexture texture, boolean interpolation)
  {
    this(frame_name, texture.getBufferedImage(), interpolation);
  }
  */
  
  /**
   * ...
   * 
   * @param frame_name
   * @param image
   */
  public SJFrameImage(String frame_name, BufferedImage image)
  {
    this(frame_name, image, DEFAULT_INTERPOLATION);
  }
  
  /**
   * ...
   * 
   * @param frame_name
   * @param image
   * @param interpolation
   */
  public SJFrameImage(String frame_name, BufferedImage image, boolean interpolation)
  {
    setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        
    // Position et taille de la fentre.
    setBounds(INI_X + translation, INI_Y + translation, 500, 500);
    translation += DS;
    
    this.setTitle(frame_name);
    
    //Le panel du renderer
    this.contentPane = new SJPanelImage(interpolation);
    this.contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
    this.contentPane.setLayout(new BorderLayout(0, 0));
    this.contentPane.setPreferredSize(getMaximumSize());       
    setContentPane(this.contentPane);
    
    this.contentPane.setBufferedImage(image);
    
    repaint();
  }
    
  /**
   * ...
   * 
   * @param image
   */
  public void setBufferedImage(BufferedImage image)
  {
    this.contentPane.setBufferedImage(image);
    repaint();
  }
  
}
