package sim.application.util;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import sim.application.SIMLearning;
import sim.util.SLog;

import java.awt.GridLayout;
import javax.swing.JButton;
import javax.swing.JTextPane;
import javax.swing.JScrollPane;
import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * La classe <b>SJFrameSIMLearning</b> reprsente la version application du programme SIMLearning
 * o le menu est prsent dans un JFrame.
 * 
 * @author Simon Vezina
 * @since 2020-03-21
 * @version 2022-01-07
 */
public class SJFrameSIMLearning extends JFrame {

  /**
   * 
   */
  private static final long serialVersionUID = 8956811403027700483L;
  
  private JPanel contentPane;
  private JTextPane textPane;

  /**
   * Launch the application.
   */
  public static void main(String[] args) {
    EventQueue.invokeLater(new Runnable() {
      public void run() {
        try {
          SJFrameSIMLearning frame = new SJFrameSIMLearning();
          frame.setVisible(true);
        } catch (Exception e) {
          e.printStackTrace();
        }
      }
    });
  }

  /**
   * Create the frame.
   */
  public SJFrameSIMLearning() {
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    setBounds(100, 100, 800, 800);
    contentPane = new JPanel();
    contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
    setContentPane(contentPane);
    contentPane.setLayout(new BorderLayout(0, 0));
    
    JPanel panelNorth = new JPanel();
    contentPane.add(panelNorth, BorderLayout.NORTH);
    panelNorth.setLayout(new GridLayout(9, 1, 0, 0));
    
    JButton button1 = new JButton("Prelaboratoire - Partie 1 (Activation de la couche)");
    button1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        textPane.setText("");
        SIMLearning.prelaboratoirePartie1();
      }
    });
    panelNorth.add(button1);
    
    JButton button2 = new JButton("Table de v\u00E9rit\u00E9 ET (AND)");
    button2.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        textPane.setText("");
        SIMLearning.and();
      }
    });
    panelNorth.add(button2);
    
    JButton button3 = new JButton("Breast Cancer Wisconsin (Diagnostic) Data Set");
    button3.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        textPane.setText("");
        SIMLearning.wdbc();
      }
    });
    panelNorth.add(button3);
    
    JButton button4 = new JButton("MNIST Data Set");
    button4.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) 
      {
        textPane.setText("");
        
        // Faire cette tche dans un nouveau thread.
        Runnable run = new Runnable() {
          
          @Override
          public void run() 
          { 
            SIMLearning.mnist();
          }
        };
       
         // Lancer l'excution du runnable.
         new Thread(run).start();
      }
    });
    panelNorth.add(button4);
    
    JButton button5 = new JButton("Pr\u00E9laboratoire - Partie 2 (Propagation de l'erreur)");
    button5.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        textPane.setText("");
        SIMLearning.prelaboratoirePartie2();
      }
    });
    panelNorth.add(button5);
    
    JButton button6 = new JButton("Apprentissage de la table de v\u00E9rit\u00E9 ET (AND)");
    button6.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        textPane.setText("");
        SIMLearning.learningAnd();
      }
    });
    panelNorth.add(button6);
    
    JButton button7 = new JButton("Apprentissage Breast Cancer Wisconsin (Diagnostic) Data Set");
    button7.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        textPane.setText("");
        SIMLearning.learningWDBC();
      }
    });
    panelNorth.add(button7);
    
    JButton button8 = new JButton("Apprentissage MNIST Data Set");
    button8.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e)
      {
        textPane.setText("");
        
        // Faire cette tche dans un nouveau thread.
        Runnable run = new Runnable() {
          
          @Override
          public void run() 
          { 
            SIMLearning.learningMNIST();
          }
        };
       
         // Lancer l'excution du runnable.
         new Thread(run).start();
     }
    });
    panelNorth.add(button8);
    
    JButton button9 = new JButton("Apprentissage Classification Couleur");
    button9.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        textPane.setText("");
        SIMLearning.learningColorClassifier();
      }
    });
    panelNorth.add(button9);
    
    JPanel panelCenter = new JPanel();
    contentPane.add(panelCenter, BorderLayout.CENTER);
    textPane = new JTextPane();
    textPane.setPreferredSize(new Dimension(700, 500));
    textPane.setText("");
    panelCenter.add(textPane);
    SLog.setJTextPane(textPane);
    
    JScrollPane scrollPane = new JScrollPane(textPane, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);  
    panelCenter.add(scrollPane);
  }

}
