/**
 * 
 */
package sim.graphics;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.Stroke;
import java.awt.geom.Line2D;
import java.awt.image.BufferedImage;

/**
 * La classe <b>SBufferedImageUtil</b> est une classe utilitaire pour faire des oprations sur des <b>BufferedImage</b>.
 * 
 * @author Simon Vezina
 * @since 2020-07-23
 * @version 2020-07-23
 */
public class SBufferedImageUtil {

  /**
   * ...
   * 
   * @param image
   * @param x
   * @param y
   * @param size La taille des caractres.
   * @param color
   * @param string
   */
  public static void drawString(BufferedImage image, int x, int y, int size, Color color, String string)
  {
    Graphics2D g2 = image.createGraphics();
    
    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    Font font = new Font("TimesRoman", Font.PLAIN, size);
    g2.setFont(font);
    g2.setColor(color);

    g2.drawString(string, x, y);
  }
  
  /**
   * Mthode pour dessiner une ligne  l'intrieur d'une image de type BufferedImage.
   * 
   * @param image
   * @param x1
   * @param y1
   * @param x2
   * @param y2
   * @param color
   * @param size
   */
  public static void drawLine(BufferedImage image, int x1, int y1, int x2, int y2, Color color, float size)
  {
    // Contexte des utilitaire graphique.
    Graphics2D g2 = image.createGraphics();
    
    // Dfinition de la couleur.
    g2.setColor(color);
    
    // Dfinition de l'tat du trait en spcifiant uniquement son paisseur ( 2 pixels).
    Stroke stroke = new BasicStroke(size);
    g2.setStroke(stroke);
    
    // Dessiner la ligne.
    g2.draw(new Line2D.Double(x1, y1, x2, y2));
  }
  
}
