/**
 * 
 */
package sim.nn.function;

/**
 * L'interface <b>SComputeErrorFunctionGradientActivationParameters<b> permet  une classe d'tre apte  calculer le gradient de la fonction d'erreur par rapport aux paramtres d'activation d'une couche de neurones.
 * 
 * @author Simon Vezina
 * @since 2021-12-05
 * @version 2021-12-05
 */
public interface SComputeErrorFunctionGradientActivationParameters {

  /**
   * <p> 
   * Mthode valuant la drive partielle dC/dK_i_u de la fonction d'erreur C par rapport au paramtre d'activation K_i_u pour une couche de neurones donnes.
   * </p>
   * <p>
   * Le calcul est effectu  partir de l'erreur propage  la fonction o une activation et une propagation de l'erreur devront tre ralises pralablement.
   * </p>
   * 
   * @param index L'indice du type de paramtre (si la fonction d'activation contient un paramtre d'activation).
   * @param u L'indice de sortie du paramtre d'activation.
   * @return La drive partielle de la fonction d'erreur C par rapport au paramtre K_i_u.
   * @throws IllegalArgumentException Si l'indice du type de paramtre n'est pas valide avec le choix de la fonction d'activation.
   */
  public double dCdK(int i, int u) throws IllegalArgumentException;
  
}
