/**
 * 
 */
package sim.nn.function;

/**
 * <p>
 * L'interface <b>SComputeErrorFunctionGradientBias</b> permet  une classe d'tre apte  calculer le gradient de la fonction d'erreur par rapport aux biais d'une couche de neurones.
 * Ce paramtre est associ  la fonction d'agrgation (<i>aggregation function</i>) et  la fonction de convolution (<i>convolution function</i>).
 * </p>
 * <p>
 * Ainsi, la classe pourra raliser le calcul 
 * <ul> dC/dBu </ul>
 * o C est la fonction d'erreur, B est le biais et u est l'indice de sortie du biais.
 * 
 * @author Simon Vezina
 * @since 2021-11-26
 * @version 2021-11-26
 */
public interface SComputeErrorFunctionGradientBias {

  /**
   * <p> 
   * Mthode valuant la drive partielle dC/dB_u de la fonction d'erreur C par rapport au biais B_u pour une couche de neurones donnes.
   * </p>
   * <p>
   * Le calcul est effectu  partir de l'erreur propage  la fonction o une activation et une propagation de l'erreur devront tre ralises pralablement.
   * </p>
   * 
   * @param u L'indice de sortie du biais.
   * @return La drive partielle de la fonction d'erreur C par rapport au biais B_u.
   */
  public double dCdB(int u);
  
}
