/**
 * 
 */
package sim.nn.function;

/**
 * <p>
 * L'interface <b>SComputeErrorFunctionGradientBias</b> permet  une classe d'tre apte  calculer le gradient de la fonction d'erreur par rapport aux <i>scale</i> d'une couche de neurones.
 * Ce paramtre est associ  la fonction de normalisation <i>batch-normalization</i>.
 * </p>
 * <p>
 * Ainsi, la classe pourra raliser le calcul 
 * <ul> dC/dSC_u </ul>
 * o C est la fonction d'erreur, SC est le <i>scale</i> et u est l'indice de sortie du <i>scale</i>.
 * 
 * @author Simon Vezina
 * @since 2021-11-26
 * @version 2021-11-26
 */
public interface SComputeErrorFunctionGradientScale {

  /**
   * ...
   * 
   * @param u
   * @return
   */
  public double dCdSC(int u);
  
}
