/**
 * 
 */
package sim.nn.function;

/**
 * <p>
 * L'interface <b>SComputeErrorFunctionGradientShift</b> permet  une classe d'tre apte  calculer le gradient de la fonction d'erreur par rapport aux <i>shift</i> d'une couche de neurones.
 * Ce paramtre est associ  la fonction de normalisation <i>batch-normalization</i>.
 * </p>
 * <p>
 * Ainsi, la classe pourra raliser le calcul 
 * <ul> dC/dSH_u </ul>
 * o C est la fonction d'erreur, SH est le <i>shift</i> et u est l'indice de sortie du <i>shift</i>.
 * 
 * @author Simon Vezina
 * @since 2021-11-26
 * @version 2021-11-26
 */
public interface SComputeErrorFunctionGradientShift {

  /**
   * ...
   * 
   * @param u
   * @return
   */
  public double dCdSH(int u);
  
}
