/**
 * 
 */
package sim.nn.function;

import sim.nn.SActivable;

/**
 * Interface <b>SNeuralFunction</b> reprsente une fonction mathmatique applique sur les neurones d'un rseau de neurones.
 * 
 * @author Simon Vezina
 * @since 2018-08-23
 * @version 2022-01-04
 */
public interface SNeuralFunction extends SActivable {

  //------------------------
  // Les fonctions d'erreur.
  //------------------------
  
  /**
   * La constante <b>ENERGY_ERROR_FUNCTION</b> reprsente le nom de la fonction d'erreur quadratique correspondant  {@value}.
   */
  public static final String ENERGY_ERROR_FUNCTION = "energy";
  public static final String LINEAR_ERROR_FUNCTION = "linear";
  public static final String CROSS_ENTROPY_ERROR_FUNCTION = "cross-entropy";
  
  //-----------------------------
  // Les fonctions d'aggrgation.
  //-----------------------------
  /**
   * La constante <b>WEIGHTED_SUM_FUNCTION</b> reprsente le nom de la fonction d'aggation de la somme pondre correspondant  {@value}.
   */
  public static final String WEIGHTED_SUM_FUNCTION = "weighted_sum";
  
  public static final String QUADRIC_SUM_FUNCTION = "quadric_sum";
  
  //----------------------------
  // Les fonctions d'activation.
  //----------------------------
  /**
   * La constante <b>SIGMOID_FUNCTION</b> reprsente le nom de la fonction d'activagtion sigmode  {@value}.
   */
  public static final String SIGMOID_FUNCTION = "sigmoid";
  
  /**
   * La constante <b>TANH_FUNCTION</b> reprsente le nom de la fonction d'activation tangent hyperbolique  {@value}.
   */
  public static final String TANH_FUNCTION = "tanh";
  
  public static final String GAUSSIAN_FUNCTION = "gaussian";
  public static final String LINEAR_FUNCTION = "linear";
  public static final String RELU_FUNCTION = "relu";
  public static final String SOFTMAX_FUNCTION = "softmax";
  public static final String SOFTSIGN_FUNCTION = "softsign";
  public static final String SWISH_FUNCTION = "swish";
  
  // Les fonctions de normalisation.
  public static final String BATCH_NORMALIZATION_FUNCTION = "batch-normalization";
  public static final String DROPOUT_FUNCTION = "dropout";
  
  // Les fonctions de filtrage.
  public static final String CONVOLUTION_FUNCTION = "convolution";
  public static final String MAX_POOLING_FUNCTION = "max_pooling";
  public static final String ABSOLUTE_MAX_POOLING_FUNCTION = "absolute_max_pooling";
  
  /**
   * Mthode pour obtenir le nom de la fonction oprant sur les neurones d'un rseau.
   * 
   * @return Le nom de la fonction.
   */
  public String getFunctionName();
  
}
