/**
 * 
 */
package sim.nn.function;

import sim.exception.SNaNValueException;
import sim.exception.SNoImplementationException;
import sim.math.SBufferedMatrix;
import sim.math.SMath;
import sim.util.SArrays;

/**
 * La classe <b>SNeuralMath</b> est une classe utilitaire contenant des fonctions mathmatiques ncessaire au fonctionnement d'un rseau de neurones.
 * 
 * @author Simon Vzina
 * @since 2018-05-05
 * @version 2022-09-14 (Version labo : Apprentissage par rseau de neurones)
 */
public class SNeuralMath {

  /**
   * Mthode pour effectuer le calcul de la <u>fonction de la somme pondre</u> 
   *  partir d'un vecteur d'entre <i>a</i>, d'une matrice de poids <i>w</i> et d'un vecteur de biais <i>b</i> pour un neurone u.
   * 
   * @param u L'indice du neurone  calculer.
   * @param a Le vecteur d'entre.
   * @param w La matrice des poids.
   * @param b Le vecteur des biais.
   * @return La somme pondre du neurone u. 
   */
  public static double weightedSum(int u, double[] a, SBufferedMatrix w, double[] b)
  {
    throw new SNoImplementationException();
    
  }
        
  /**
   * Mthode effectuant de la fonction <u>linaire</u>. Les valeurs de sortie de cette fonction d'activation sont situes dans l'intervalle [-infini, infini].
   * 
   * @param x L'entre de la fonction.
   * @return Le rsultat de la fonction.
   */
  public static double linear(double x)
  {   
    return x;
  }
  
  /**
   * Mthode effectuant le calcul de la <u>drive de la fonction linaire</u>.
   * 
   * @param x L'entre de la fonction.
   * @return La drive de la fonction.
   */
  public static double derivateLinear(double x)
  {
    return 1.0;
  }
  
  /**
   * <p>
   * Mthode effectuant le calcul de la fonction nomme <u>sigmode</u>. Les valeurs de sortie de cette fonction d'activation sont situes dans l'intervalle [0, 1].
   * </p>
   * <p>
   * Cette fonction correspond au calcul suivant :
   * <ul> y = 1 / ( 1 + e^-x)</ul>
   * Cette fonction est utilise dans des rseaux de neurone en intelligence artificielle comme fonction dite <u>d'activation</u>.
   * </p>
   * 
   * @param x L'entre de la fonction.
   * @return La fonction sigmode value en x.
   */
  public static double sigmoid(double x)
  {
    throw new SNoImplementationException();
    
  }
  
  /**
   * <p>
   * Mthode effectuant le calcul de la <u>drive de la fonction sigmode</u>.
   * </p>
   * <p>
   * Puisque la fonction sigmode est gale  l'expression
   * <ul> y = 1 / ( 1 + e^-x) ,</ul>
   * la drive de cette fonction sera gale  l'expression
   * <ul> dy/dx = y * (1 - y)<ul>.
   * </p>
   * 
   * @param x L'entre de la fonction.
   * @return La drive de la fonction sigmode value en x.
   */
  public static double derivateSigmoid(double x)
  {
    throw new SNoImplementationException();
    
  }

  /**
   * Mthode effectuant le calcul de la fonction ReLU (rectifier). 
   * Les valeurs de sortie de cette fonction d'activation sont situes dans l'intervalle [0, infini] selon l'quation suivante :
   * <ul> ReLU(x) = x si x > 0</ul>
   * <ul> ReLU(x) = 0 si x <= 0</ul>
   * 
   * @param x L'entre de la fonction.
   * @return Le rsultat de la fonction.
   */
  public static double ReLU(double x)
  {
    throw new SNoImplementationException();
    
  }
  
  /**
   * Mthode effectuant le calcul de la drive de la fonction ReLU.
   * 
   * @param x L'entre de la fonction.
   * @return La fonction ReLU value en x.
   */
  public static double derivateReLU(double x)
  {
    throw new SNoImplementationException();
    
  }
    
  /**
   * Mthode effectuant le calcul de la fonction <u>softmax</u>.
   * 
   * Voir le site suivant pour une vection de la fonction avec plus de stabilit numrique :
   * https://eli.thegreenplace.net/2016/the-softmax-function-and-its-derivative/
   * 
   * @param x Le vecteur sur lequel la fonction est opre.
   * @param u L'indice du paramtre du vecteur x sur lequel le calcul de la fonction sera effectu.
   * @return Le rsultat de la fonction softmax sur le paramtre u. 
   */
  public static double softmax(double[] x, int u)
  {
    throw new SNoImplementationException();
    
  }
  
  /**
   * Mthode effectuant le calcul de la <b>drive de la fonction softmax</b>.
   * 
   * @param x Le vecteur sur lequel la fonction est opre.
   * @param u L'indice du paramtre du vecteur x sur lequel le calcul de la fonction sera effectu.
   * @param k L'indice du paramtre du vecteur x par rapport auquel le calcul de la drive est effectu. 
   * @return Le rsultat de la drive de la fonction softmax sur le paramtre u par rapport au paramtre v. 
   */
  public static double derivateSoftmax(double[] x, int u, int k)
  {
    throw new SNoImplementationException();
    
  }
    
  /**
   * <p>
   * ... . Les valeurs de sortie de cette fonction d'activation sont situes dans l'intervalle [-1, 1].
   * 
   * Cette fonction correspond au calcul suivant :
   * <ul> y = x / ( 1 + abs(x) ) </ul>
   * </p>
   * @param x
   * @return
   */
  public static double softsign(double x)
  {
    throw new SNoImplementationException();
    
  }
  
  /**
   * ...
   * 
   * @param x
   * @return
   */
  public static double derivateSoftsign(double x)
  {
    throw new SNoImplementationException();
    
  }
  
  /**
   * <p>
   * Mthode qui effectue le calcul de la fonction tangente hyperbolique (tanh(x)).
   * </p>
   * <p>
   * Les valeurs de sortie de cette fonction d'activation sont situes dans l'intervalle [-1, 1].
   * </p>
   * 
   * @param x L'entre de la fonction.
   * @return La valeur de la fonction.
   */
  public static double tanh(double x)
  {
    throw new SNoImplementationException();
    
  }
  
  /**
   * Mthode qui value la drive de la fonction tangente hyperbolique (d(tan(x))/dx).
   * 
   * @param x L'entre de la fonction.
   * @return La valeur de la fonction.
   */
  public static double derivateTanh(double x)
  {
    throw new SNoImplementationException();
    
  }
  
  /**
   * ... . Les valeurs de sortie de cette fonction d'activation sont situes dans l'intervalle [0, 1].
   * 
   * @param x
   * @return
   */
  public static double gaussian(double x)
  {
    throw new SNoImplementationException();
    
  }
  
  /**
   * ...
   * 
   * @param x
   * @return
   */
  public static double derivateGaussian(double x)
  {
    throw new SNoImplementationException();
    
  }
  
  /**
   * Mthode qui effectue le calcul de l'erreur linraire entre deux valeurs.
   * 
   * @param calculated La valeur calcule.
   * @param expected La valeur attendue.
   * @return L'erreur.
   */
  public static double linearError(double calculated, double expected)
  {
    return Math.abs(calculated-expected);
  }
   
  /**
   * Mthode qui effectue le calcul de la drive de l'erreur linaire.
   * 
   * @param calculated La valeur calcule.
   * @param expected La valeur attendue.
   * @return La drive de l'erreur.
   */
  public static double derivateLinearError(double calculated, double expected)
  {
    return Math.signum(calculated-expected);
  }
  
  /**
   * <p>
   * Mthode permettant d'valuer l'erreur de la fonction de cot <u>sur un neurones</u>  l'aide de l'quation quadratique.
   * </p>
   * <p>
   * Cette quation correspond  l'expression suivante :
   * <ul> <i>E</i> = 1/2 ( <i>a</i> - <i>y</i> )^2</ul>
   * o <i>a</i> correspond  la valeur calcule (l'activation d'un neurone) et <i>y</i>  la valeur attendue.
   * </p>
   * 
   * @param calculated La valeur calcule.
   * @param expected La valeur attendue.
   * @return L'erreur quadratique.
   */
  public static double quadraticError(double calculated, double expected)
  {
    throw new SNoImplementationException();
    
  }
  
  /**
   * Mthode permettant d'valuer le taux de variations d'une erreur quadratique.
   * 
   * @param calculated La valeur calcule.
   * @param expected La valeur attendue.
   * @return Le taux de variation de l'erreur quadratique.
   */
  public static double derivateQuadraticError(double calculated, double expected)
  {
    throw new SNoImplementationException();
    
  }
  
  /**
   * ...
   * 
   * Rfrence : https://en.wikipedia.org/wiki/Cross_entropy
   *             https://datascience.stackexchange.com/questions/9302/the-cross-entropy-error-function-in-neural-networks
   * 
   * @param calculated
   * @param expected
   * @throws IllegalArgumentException
   * @return
   */
  public static double crossEntropyError(double calculated, double expected) throws SNaNValueException
  {
    // valuons le cas spciale o la valeur calcule est exactement la valeur attendue,
    // mais que c'est 0.0 qui est dans le calcul. Ceci mnera  0.0 * - l'infini ce qui est indtermin.
    // Dans ce cas, nous allons dfinir la rponse  0.0, donc pas d'erreur.
    if(calculated == 0.0 && expected == 0.0)
      return 0.0;
    
    throw new SNoImplementationException();
    
  }
  
  /**
   * ...
   * 
   * @param calculated
   * @param expected
   * @throws IllegalArgumentException
   * @return
   */
  public static double derivateCrossEntropyError(double calculated, double expected) throws SNaNValueException
  {
    // valuons le cas spciale o la valeur calcule est exactement la valeur attendue,
    // mais que c'est 0.0 qui est dans le calcul. Ceci mnera  -0.0 / 0.0 ce qui est indtermin.
    // Dans ce cas, nous allons dfinir la rponse  0.0, donc pas de propagation d'erreur.
    if(calculated == 0.0 && expected == 0.0)
      return 0.0;
    
    throw new SNoImplementationException();
    
  }
  
  /**
   * <p>
   * Mthode qui effectue le calcule de l'apprentissage de la descente du gradient stochastique (<i>stochastic gradient descent learning</i>).
   * </p>
   * <p>
   * Les quations associes  cet algoritme de renforcement est disponible au lien suivant :
   * <ul>https://en.wikipedia.org/wiki/Stochastic_gradient_descent</ul>
   * </p>
   * @param V La valeur courante de la fonction (<i>current value</i>).
   * @param gradient Le gradient de la fonction par rapport  V.
   * @param alpha Le taux d'apprentissage (<i>learning rate</i>) qui doit tre situ idalement dans l'intervalle [0,1].
   * @return La valeur de la fonction aprs l'apprentissage.
   */
  public static double learning(double V, double gradient, double alpha)
  {
    throw new SNoImplementationException();
    
  }
    
  /**
   * Mthode pour dterminer le offset d'entre d'une couche en profondeur de forme carr.
   * 
   * Le offset reprsente la largeur et la hauteur de la couche de profondeur qui doit tre de format carr.
   * 
   * @param inputs Le nombre de neurones en entre.
   * @param inputs_depth Le niveau de profondeur de la couche d'entre. 
   * @return Le offset (largeur et hauteur) de l'entre de format carr.
   */
  public static int computeInputsOffsetForSquareInputsDepth(int inputs, int inputs_depth) throws IllegalArgumentException
  {
    // Diviser l'entre par la profondeur.
    int inputs_per_depth = inputs / inputs_depth;
    
    // Validation qu'il y a autant sous-entre pour chaque profondeur
    if(inputs_per_depth * inputs_depth != inputs)
      throw new IllegalArgumentException("Erreur SNeuralMath 006 : Le input = " + inputs + " n'est pas divisible par la profondeur input_depth = " + inputs_depth + ".");
    
    // Faire la racine carre 
    int offset = (int) Math.round(Math.sqrt((double)inputs_per_depth));
    
    // Validation de la forme carr des entres.
    if(offset*offset != inputs_per_depth)
      throw new IllegalArgumentException("Erreur SNeuralMath 007 : Le calcul du offset de l'entre par profondeur ne correspond pas  une entre carr, car input_per_depth = " + inputs_per_depth + " et offset = " + offset + ". Alors offset*offset = " + (offset*offset) + ".");
        
    return offset;
  }
  
  /**
   * <p>
   * Mthode pour dterminer le offset de la sortie pour une couche d'entre avec profondeur de forme carr.
   * </p>
   * <p>
   * <u>Rfrence</u> : https://blog.mlreview.com/a-guide-to-receptive-field-arithmetic-for-convolutional-neural-networks-e0f514068807?gi=71f5867fd2b9
   * </p>
   * 
   * @param inputs
   * @param inputs_depth
   * @param kernel_offset
   * @param padding
   * @param stride
   * @return
   */
  public static int computeOutputsOffsetForSquareInputsDepth(int inputs, int inputs_depth, int kernel_offset, int padding, int stride)
  {
    int inputs_offset = computeInputsOffsetForSquareInputsDepth(inputs, inputs_depth);
    
    return (inputs_offset + 2*padding - kernel_offset) / stride + 1;
  }
  
  /**
   * Mthode pour dterminer le nombre de neurones en sortie pour une entre avec couche de forme carr.
   * 
   * @param inputs Le nombre de neurones en entre.
   * @param inputs_depth Le niveau de profondeur d'entre.
   * @param outputs_depth Le niveau de profondeur de sortie.
   * @param kernel_offset La taille du filtre carr.
   * @param padding Le padding.
   * @param stride Le stride.
   * @return Le nombre de neurones en sortie.
   */
  public static int computeOutputsSizeForSquareInputsDepth(int inputs, int inputs_depth, int outputs_depth, int kernel_offset, int padding, int stride)
  {
    int output_offset = computeOutputsOffsetForSquareInputsDepth(inputs, inputs_depth, kernel_offset, padding, stride);
    
    return outputs_depth * output_offset*output_offset;
  }
  
}
