/**
 * 
 */
package sim.nn.function.activation;

import sim.exception.SNoImplementationException;

/**
 * La classe <b>SFullActivationFunction</b> reprsente une fonction d'activation de type <i>full-connected</i>.
 * 
 * @author Simon Vzina
 * @since 2018-12-24
 * @version 2022-09-13 (Version labo : Apprentissage par rseau de neurones)
 */
public abstract class SFullActivationFunction extends SActivationFunction {

  /**
   * Constructeur d'une fonction d'activation de type <i>full-connected</i>.
   * 
   * @param neurons Le nombre de neurones dans la fonction d'activation.
   */
  public SFullActivationFunction(int neurons)
  {
    super(neurons);
  }

  @Override
  public boolean isFullActivationFunction()
  {
    return true;
  }

  @Override
  public double dAdZ(int u) 
  {
    throw new UnsupportedOperationException("Erreur SFullActivationFunction 001 : La mthode suivante n'est pas supporte : public double dfdZ(int u). Puisque cette fonction d'activation require un vecteur et non une seule donne, il faut imprativement prciser par rapport  quelle valeur il faut effectuer la drive.");
  }
  
  @Override
  public double backward(int u)
  {
    throw new SNoImplementationException();
    
  }
  
}
