/**
 * 
 */
package sim.nn.function.activation;

import sim.exception.SConstructorException;
import sim.nn.function.SNeuralFunction;
import sim.nn.function.SNeuralMath;

/**
 * La classe <b>SGaussianFunction</b> reprsente la fonction d'activation portant le nom de <b>Gaussian</b> correspondant  la fonction Gaussienne.
 *
 * @author Simon Vzina
 * @since 2018-05-25
 * @version 2021-12-05
 */
public class SGaussianFunction extends SActivationFunction {

  /**
   * ...
   * 
   * @param neurons
   * @throws SConstructorException
   */
  public SGaussianFunction(int neurons) throws SConstructorException
  {
    super(neurons);
  }

  @Override
  public double forward(int u)
  {
    return SNeuralMath.gaussian(this.forward_inputs[u]);
  }

  @Override
  public double dAdZ(int u)
  {
    return SNeuralMath.derivateGaussian(this.forward_inputs[u]);
  }

  @Override
  public String getFunctionName() 
  {
    return SNeuralFunction.GAUSSIAN_FUNCTION;
  }
  
}
