/**
 * 
 */
package sim.nn.function.activation;

import sim.exception.SConstructorException;
import sim.nn.function.SNeuralFunction;
import sim.nn.function.SNeuralMath;

/**
 * La classe <b>SLinearFunction</b> reprsente la fonction d'activation de type linaire.
 * 
 * @author Simon Vzina
 * @since 2018-05-15
 * @version 2019-06-03
 */
public class SLinearFunction extends SActivationFunction {

  /**
   * Constructeur de la fonction d'activation linaire.
   * 
   * @param neurons Le nombre de neurones.
   * @throws SConstructorException S'il y a eu une erreur lors de la construction de cette fonction.
   */
  public SLinearFunction(int neurons) throws SConstructorException
  {
    super(neurons);
  }

  @Override
  public double forward(int u)
  {
    return SNeuralMath.linear(this.forward_inputs[u]);
  }

  @Override
  public double dAdZ(int u) 
  {
    return SNeuralMath.derivateLinear(this.forward_inputs[u]);
  }
  
  @Override
  public String getFunctionName() 
  {
    return SNeuralFunction.LINEAR_FUNCTION;
  }
  
}
