/**
 * 
 */
package sim.nn.function.activation;

import sim.exception.SConstructorException;
import sim.nn.function.SNeuralFunction;
import sim.nn.function.SNeuralMath;

/**
 * La classe <b>SReluFunction</b> reprsente la fonction d'activation portant le nom de <b>ReLU</b>.
 * 
 * @author Simon Vzina
 * @since 2018-03-17
 * @version 2021-12-05
 */
public class SReluFunction extends SActivationFunction {

  /**
   * ...
   * 
   * @param neurons
   * @throws SConstructorException
   */
  public SReluFunction(int neurons) throws SConstructorException
  {
    super(neurons);
  }

  @Override
  public double forward(int u)
  {
    return SNeuralMath.ReLU(this.forward_inputs[u]);
  }

  @Override
  public double dAdZ(int u) 
  {
    return SNeuralMath.derivateReLU(this.forward_inputs[u]);
  }

  @Override
  public String getFunctionName() 
  {
    return SNeuralFunction.RELU_FUNCTION;
  }
  
}
