/**
 * 
 */
package sim.nn.function.activation;

import sim.exception.SConstructorException;
import sim.nn.function.SNeuralFunction;
import sim.nn.function.SNeuralMath;

/**
 * La classe <b>SSigmoidFunction</b> reprsente la fonction d'activation sigmode.
 * Cette fonction permet  l'agrgation Z d'un neurone d'tre recadr en activation A dans l'intervalle [0,1].
 * 
 * @author Simon Vezina
 * @since 2018-03-17
 * @version 2022-09-13 (Version labo : Apprentissage par rseau de neurones)
 */
public class SSigmoidFunction extends SActivationFunction {
  
  //----------------
  // CONSTRUCTEUR //
  //----------------
  
  /**
   * Constructeur de la fonction d'activation sigmoide.
   * 
   * @param neurons
   * @throws SConstructorException
   */
  public SSigmoidFunction(int neurons) throws SConstructorException
  {
    super(neurons);
  }
  
  //------------
  // MTHODES //
  //------------
  
  @Override
  protected double forward(int u)
  {
    return SNeuralMath.sigmoid(this.forward_inputs[u]);
  }

  @Override
  public double dAdZ(int u) 
  {
    return SNeuralMath.derivateSigmoid(this.forward_inputs[u]);  
    
    
  }
 
  @Override
  public String getFunctionName() 
  {
    return SNeuralFunction.SIGMOID_FUNCTION;
  }
  
}
