/**
 * 
 */
package sim.nn.function.activation;

import sim.exception.SConstructorException;
import sim.nn.function.SNeuralFunction;
import sim.nn.function.SNeuralMath;

/**
 * La classe <b>SSoftsignFunction</b> reprsente la fonction d'activation portant le nom de <b>Softsign</b>.
 * 
 * @author Simon Vzina
 * @since 2018-05-25
 * @version 2021-10-10
 */
public class SSoftsignFunction extends SActivationFunction {

 /**
   * ...
   * 
   * @param neurons
   * @throws SConstructorException
   */
  public SSoftsignFunction(int neurons) throws SConstructorException
  {
    super(neurons);
  }

  @Override
  public double forward(int u)
  {
    return SNeuralMath.softsign(this.forward_inputs[u]);
  }

  @Override
  public double dAdZ(int u)
  {
    return SNeuralMath.derivateSoftsign(this.forward_inputs[u]);
  }
  
  @Override
  public String getFunctionName() 
  {
    return SNeuralFunction.SOFTSIGN_FUNCTION;
  }
  
}
