/**
 * 
 */
package sim.nn.function.aggregation;

import sim.exception.SNoImplementationException;
import sim.nn.function.SNeuralFunction;

/**
 * La classe <b>SQuadricSumFunction</b> reprsente la fonction d'agrgation de la somme quadratique (invention de Simon Vzina sous toute rserve).
 * 
 * @author Simon Vezina
 * @since 2019-10-30
 * @version 2022-09-13 (Version labo : Apprentissage par rseau de neurones)
 */
public class SQuadricSumFunction extends SAggregationFunction {

  /**
   * La constante <b>ORDER</b> reprsente l'ordre de la fonction d'agrgation de la somme quadratique gal  {@value}.
   */
  public static final int ORDER = 2;
  
  /**
   * Constructeur d'une fonction d'agrgation de type somme quadratique (<i>quadric sum</i>).
   * 
   * @param input_size Le nombre de neurones en entre dans la couche.
   * @param output_size Le nombre de neurones en sortie de la couche.
   */
  public SQuadricSumFunction(int input_size, int output_size) 
  {
    super(input_size, output_size);
  }

  @Override
  public double dCdW(int v, int u, int o) throws IllegalArgumentException 
  {
    throw new SNoImplementationException();
    
  }

  @Override
  public String getFunctionName() 
  {
    return SNeuralFunction.QUADRIC_SUM_FUNCTION;
  }

  @Override
  protected double forward(int u) 
  {
    throw new SNoImplementationException();
    
  }

  @Override
  public double dZdW(int u, int v, int o) throws IllegalArgumentException
  {
    throw new SNoImplementationException();
  }

  @Override
  public double dZdB(int u) 
  {
    return 1.0;
  }
  
  @Override
  public double dZdA(int u, int v) 
  {
    throw new SNoImplementationException();
    
  }

  @Override
  public int getOrder() 
  {
    return SQuadricSumFunction.ORDER;
  }
  
}
