/**
 * 
 */
package sim.nn.function.error;

import sim.nn.function.SNeuralFunction;
import sim.nn.function.SNeuralMath;

/**
 * La classe <b>SEntropyErrorFunction</b> reprsente la fonction d'erreur portant le nom d'entropie croise (<i>cross-entropy</i>).
 * 
 * @author Simon Vzina
 * @since 2018-05-10
 * @version 2022-01-08
 */
public class SCrossEntropyErrorFunction extends SErrorFunction {

  /**
   * ...
   * 
   * @param neurons
   */
  public SCrossEntropyErrorFunction(int neurons) 
  {
    super(neurons);
  }
 
  @Override
  public double dCdA(int u) 
  {
    return SNeuralMath.derivateCrossEntropyError(this.forward_inputs[u], this.y[u]);    
  }

  @Override
  public double forward(int u)
  {
    return SNeuralMath.crossEntropyError(this.forward_inputs[u], this.y[u]);
  }

  @Override
  public String getFunctionName()
  {
    return SNeuralFunction.CROSS_ENTROPY_ERROR_FUNCTION;
  }
  
}
