/**
 * 
 */
package sim.nn.function.error;

import sim.nn.function.SNeuralFunction;
import sim.nn.function.SNeuralMath;

/**
 * La classe <b>SLinearErrorFunction</b> reprsente le fonction d'erreur <u>linaire</u>.
 * 
 * @author Simon Vzina
 * @since 2018-05-05
 * @version 2022-01-08
 */
public class SLinearErrorFunction extends SErrorFunction {

  
  /**
   * ...
   * 
   * @param neurons
   */
  public SLinearErrorFunction(int neurons)
  {
    super(neurons);
  }
  
  @Override
  public double dCdA(int u) 
  {
     return SNeuralMath.derivateLinearError(this.forward_inputs[u], this.y[u]);
  }

  @Override
  public double forward(int u) 
  {
    return SNeuralMath.linearError(this.forward_inputs[u], this.y[u]);
  }

  @Override
  public String getFunctionName() 
  {
    return SNeuralFunction.LINEAR_ERROR_FUNCTION;
  }

}
