/**
 * 
 */
package sim.nn.function.filtering;

import sim.exception.SConstructorException;
import sim.exception.SNoImplementationException;
import sim.nn.function.SNeuralFunction;

/**
 * <p>
 * La classe <b>SAbsoluteMaxPoolingFunction</b> reprsente la fonction de regroupement <i>absolute max pooling</i>.
 * Cette fonction retournera une valeur entre l'infini ngatif et l'infini positif.
 * </p>
 * <p>
 * Cette fonction a pour but d'identifier  quel point dans une section d'une image un filtre a t identifi.
 * Si le filtre est bien identifi, une valeur positive sera attribue.
 * Si le filtre est anti-idenfifi, une valeur ngative retourne. 
 * </p>
 * 
 * @author Simon Vezina
 * @since 2021-10-19
 * @version 2022-09-13 (Version labo : Apprentissage par rseau de neurones)
 */
public class SAbsoluteMaxPoolingFunction extends SPoolingFunction {

  /**
   * ...
   * 
   * @param inputs
   * @param input_depth
   * @param filter_offset
   * @param stride
   * @throws SConstructorException
   */
  public SAbsoluteMaxPoolingFunction(int inputs, int input_depth, int filter_offset) throws SConstructorException 
  {
    super(inputs, input_depth, filter_offset, filter_offset);
  }

  @Override
  protected double filtering(int f, int m, int n) 
  {
    throw new SNoImplementationException();
    
  }

  @Override
  protected double[] backwardPass()
  {
    throw new SNoImplementationException();
    
  }
  
  @Override
  public String getFunctionName() 
  {
    return SNeuralFunction.ABSOLUTE_MAX_POOLING_FUNCTION;
  }

}
