package sim.nn.function.filtering;

import sim.exception.SConstructorException;
import sim.nn.function.SAbstractFilterFunction;

/**
 * La classe <b>SPoolingFunction</b> reprsente une fonction de filtrage par regroupement d'information. Le type de regroupement dpendra du type de la fonction.
 * 
 * @author Simon Vezina
 * @since 2021-10-18
 * @version 2022-01-05
 */
public abstract class SPoolingFunction extends SAbstractFilterFunction {

  /**
   * ...
   * 
   * @param inputs
   * @param input_depth
   * @param filter_offset
   * @param stride
   * @throws SConstructorException
   */
  public SPoolingFunction(int inputs, int input_depth, int filter_offset, int stride) throws SConstructorException 
  {
    super(inputs, input_depth, input_depth, filter_offset, 0, stride);
  }

  /**
   * ...
   * 
   * @param inputs
   * @return
   * @throws IllegalArgumentException
   */
  public double[] pooling(double[] inputs) throws IllegalArgumentException
  {
    return this.forwardPropagation(inputs);
  }
     
  
}
