/**
 * 
 */
package sim.nn.gradient;

import sim.nn.layer.SLayer;

/**
 * La classe <b>SEmptyParameterGradientLayer</b> reprsente un gradient d'une fonction d'erreur pour une couche contenant aucun paramtre.
 * 
 * @author Simon Vezina
 * @since 2019-08-17
 * @version 2019-09-22
 */
public class SEmptyParameterGradientLayer implements SGradientLayer {

  @Override
  public void add(SGradientLayer layer)
  {
    // Il n'y a rien  ajouter ...
  }

  @Override
  public void add(SLayer layer)
  {
    // Il n'y a rien  ajouter ...
  }

  @Override
  public void clear() 
  {
    // Il n'y a rien  faire ...
  }

  @Override
  public void multiply(double v)
  {
    // Il n'y a rien  faire ...
  }

  @Override
  public void multiply(SGradientLayer gradient) 
  {
    // Il n'y a rien  faire ...
  }

}
