/**
 * 
 */
package sim.nn.layer;

import java.util.ArrayList;
import java.util.List;

import sim.nn.SBatchActivable;

/**
 * L'interface <b>SBatchLayer</b> reprsente une couche de neurones dont l'activation s'effectue par batch.
 * 
 * @author Simon Vezina
 * @since 2019-03-03
 * @version 2022-01-08
 */
public interface SBatchLayer extends SLayer, SBatchActivable {

  @Override
  public default double[] forwardPropagation(double[] input) throws IllegalArgumentException
  {
    List<double[]> list = new ArrayList<double[]>();
    list.add(input);
    
    return this.batchForwardPropagation(1, list).get(0);
  }
  
  @Override
  public default double[] backPropagation(double[] delta) throws IllegalArgumentException
  {
    List<double[]> list = new ArrayList<double[]>();
    
    list.add(delta);
    
    return batchBackPropagation(1, list).get(0);
  }
    
}
